#-----------------------------------------
#   plot functions
#-----------------------------------------


Traceplot_draws <- function(X, label) {
  plot(seq_along(X), X, type = "l",  col = "red", xlab = "iteration", ylab = "", ylim = range(X))
  mtext(paste(eval(label), sep = ""))
}

Traceplot_Nk <- function(X, label) {
  par(mfrow = c(1, 1))
  plot(c(1, length(X[, 1])*100), c(0, max(X)), type = "n",
       xlab = "iteration", ylab = "")
  for (k in 1:length(X[1, ])) {
      points((1:length(X[, 1])*100), X[, k], type = "l",  col = rainbow(length(X[1, ]))[k], lwd = 2.4)
  }
}

pointProcessRepresentation <- function(Mu, label) {
  r <- length(Mu[1, , 1])
  K <- length(Mu[1, 1, ])
  if (r > 2) {
    dim <- ceiling(sqrt(r*(r-1)/2))
    par(mfrow = c(dim, dim))
    for (j1 in 1:(r-1)) {
      for (j2 in (j1+1):(r)) {
        plot(0, 0, xlim = quantile(Mu[, j1, ], probs = c(0.005, 0.995)), 
             ylim = quantile(Mu[, j2, ], probs = c(0.005, 0.995)), 
             type = "n",  
             xlab = paste(eval(label), j1, sep = ""), 
             ylab = paste(eval(label), j2, sep = ""), 
             cex.lab = 1.2, 
             cex.axis = 1.2
        )
        for (k in 1:K) {
          points(Mu[, j1, k], Mu[, j2, k], col = k)
        }
      }
    }
  } else {
    plot(0, 0, xlim = quantile(Mu[, 1, ], probs = c(0.005, 0.995)), 
         ylim = quantile(Mu[, 2, ], probs = c(0.005, 0.995)),
         type = "n",  
         xlab = paste(eval(label), "1", sep = ""), 
         ylab = paste(eval(label), "2", sep = ""), 
         cex.lab = 1.2, 
         cex.axis = 1.2
    )
    for (k in 1:K) {
      points(Mu[, 1, k], Mu[, 2, k], col = k)
    }
  }
}

